/*
 * Filename      : dcomp.h
 * Purpose       : Delta compression and decompression, header file
 * Author        : Lei Yang
 * Date Created  : 03/28/2006
 * Last Modified : 
*/
#include <stddef.h>
#include <stdint.h>

#define delta_word uint16_t

#define MAGIC_CODE 0x20

#define PAGE_SIZE 256

#define TAPE_SIZE PAGE_SIZE/sizeof(delta_word)

#define HIGH_BITS 100
#define LOW_BITS 101

#define ACCEPTABLE_SIZE (PAGE_SIZE-sizeof(delta_word)-TAPE_SIZE*6/8)/sizeof(delta_word)

void delta_compress(char *src, size_t srclen, 
                   char *dest, size_t *destlen, 
									 char *working_mem);

void delta_decompress(char *src, size_t srclen,
                     char *dest, size_t *destlen,
                     char *working_mem);

