/*
 *  Filename:     solu1.h
 *  Purpose:      header file for solu1.c
 *  Description:                  
 *                
 *  Author:       Lan Bai
 *  Date Created: 2005-9-5
 *
 *  CHANGELOG:
 *       Author:  Lan Bai
 *       Date:    2005-10-5
 *       Changes: include kma_rm.c
 *
 *       Author:  
 *       Date:
 *       Changes:
 *
 */


#include "kma_rm.h"

#ifndef SOLU1_H_
#define SOLU1_H_
//#define TRANS 1

#if 0
#define TOTAL_PAGE 20 //including comp area, uncomp area
#define PAGE_SIZE 256
#define MAX_CM_PAGE 5
#define MAX_PM_PAGE (TOTAL_PAGE-MAX_CM_PAGE)
#define MAX_VM_PAGE 30
#define PM_SIZE (PAGE_SIZE*MAX_PM_PAGE)
#define VM_SIZE (PAGE_SIZE*MAX_VM_PAGE)
#define CM_SIZE (MAX_CM_PAGE*PAGE_SIZE)
#endif

#define PAGE_SIZE 256

extern int TOTAL_PAGE;
extern int MAX_CM_PAGE;
extern int MAX_PM_PAGE;
extern int MAX_VM_PAGE;
extern int PM_SIZE;
extern int VM_SIZE;
extern int CM_SIZE;

#define NEVERUSE 0x7f
#define AD_SHIFT 8
#define OFFSET_MASK 0xff

typedef uint8_t handle;

#ifdef DEBUG
extern uint8_t swap_out_num;
extern uint8_t swap_in_num;
extern uint16_t access_num;
extern float comp_ratio;
#endif

struct lru_list {
    struct lru_list * pre_p;
    uint8_t list_handle;
    struct lru_list * next_p;
};

//extern uint8_t map[MAX_VM_PAGE];
extern uint8_t map[];
//extern uint8_t freepages[MAX_PM_PAGE];
extern uint8_t freepages[];
extern uint8_t map[];
extern uint8_t freepages[];
struct lru_list free_list[20];


extern uint8_t *pm_start;
extern uint8_t *cm_start;
extern struct vminfo *pm_area;
extern struct vminfo *cm_area;
extern struct objinfo **pm_res_fp; 
extern struct objinfo **cm_res_fp; 


void initial();

void write_handle8(uint16_t, uint8_t);
void write_handle16(uint16_t, uint16_t);
void write_handle32(uint16_t, uint32_t);

void write_handle8s(uint16_t, int8_t);
void write_handle16s(uint16_t, int16_t);
void write_handle32s(uint16_t, int32_t);

uint8_t read_handle8(uint16_t vir_addr);
uint16_t read_handle16(uint16_t vir_addr);
uint32_t read_handle32(uint16_t vir_addr);

int8_t read_handle8s(uint16_t vir_addr);
int16_t read_handle16s(uint16_t vir_addr);
int32_t read_handle32s(uint16_t vir_addr);

uint16_t vir_to_phy(uint16_t);
void check_handle(handle h);
#endif /*SOLU1_H_*/
