typedef signed char __nesc_nw_int8_t;
typedef unsigned char __nesc_nw_uint8_t;
typedef short __nesc_nw_int16_t;
typedef unsigned short __nesc_nw_uint16_t;
typedef long __nesc_nw_int32_t;
typedef unsigned long __nesc_nw_uint32_t;
typedef long long __nesc_nw_int64_t;
typedef unsigned long long __nesc_nw_uint64_t;
/* Start internal network declarations*/
#define nw_struct struct
#define nw_union union

/* Base types. All this code assumes char's are 8-bits */
typedef struct nw_int8_t  { unsigned char data[1]; } __attribute__((packed)) nw_int8_t;
typedef struct nw_int16_t { unsigned char data[2]; } __attribute__((packed)) nw_int16_t;
typedef struct nw_int32_t { unsigned char data[4]; } __attribute__((packed)) nw_int32_t;
typedef struct nw_int64_t { unsigned char data[8]; } __attribute__((packed)) nw_int64_t;
typedef struct nw_uint8_t  { unsigned char data[1]; } __attribute__((packed)) nw_uint8_t;
typedef struct nw_uint16_t { unsigned char data[2]; } __attribute__((packed)) nw_uint16_t;
typedef struct nw_uint32_t { unsigned char data[4]; } __attribute__((packed)) nw_uint32_t;
typedef struct nw_uint64_t { unsigned char data[8]; } __attribute__((packed)) nw_uint64_t;

/* Network to host and host to network conversions.
   Network representation is 2's complement little-endian.
*/
static inline __nesc_nw_uint8_t NTOUH8(void *source) {
  unsigned char *base = source;
  return (unsigned char)base[0];
}
static inline __nesc_nw_uint16_t NTOUH16(void *source) {
  unsigned char *base = source;
  return base[1] << 8 | base[0];
}
static inline __nesc_nw_uint32_t NTOUH32(void *source) {
  unsigned char *base = source;
  return (__nesc_nw_uint32_t)base[3] << 24 |
         (__nesc_nw_uint32_t)base[2] << 16 |
         base[1] << 8 | base[0];
}
static inline __nesc_nw_uint64_t NTOUH64(void *source) {
  unsigned char *base = source;
  return (__nesc_nw_uint64_t)base[7] << 56 |
         (__nesc_nw_uint64_t)base[6] << 48 |
         (__nesc_nw_uint64_t)base[5] << 40 |
         (__nesc_nw_uint64_t)base[4] << 32 |
         (__nesc_nw_uint64_t)base[3] << 24 |
         (__nesc_nw_uint64_t)base[2] << 16 |
         base[1] << 8  | base[0];
}
static inline __nesc_nw_int8_t NTOH8(void *source) {
  return NTOUH8(source);
}
static inline __nesc_nw_int16_t NTOH16(void *source) {
  return NTOUH16(source);
}
static inline __nesc_nw_int32_t NTOH32(void *source) {
  return NTOUH32(source);
}
static inline __nesc_nw_int64_t NTOH64(void *source) {
  return NTOUH64(source);
}

/* Host to network order assignment */
static inline __nesc_nw_uint8_t UHTON8(void *target, __nesc_nw_uint8_t value) {
  unsigned char *base = target;
  base[0] = value;
  return value;
}
static inline __nesc_nw_uint16_t UHTON16(void *target, __nesc_nw_uint16_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  return value;
}
static inline __nesc_nw_uint32_t UHTON32(void *target, __nesc_nw_uint32_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  base[2] = value >> 16;
  base[3] = value >> 24;
  return value;
}
static inline __nesc_nw_uint64_t UHTON64(void *target, __nesc_nw_uint64_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  base[2] = value >> 16;
  base[3] = value >> 24;
  base[4] = value >> 32;
  base[5] = value >> 40;
  base[6] = value >> 48;
  base[7] = value >> 56;
  return value;
}
static inline __nesc_nw_int8_t HTON8(void *target, __nesc_nw_int8_t value) {
  unsigned char *base = target;
  base[0] = value;
  return value;
}
static inline __nesc_nw_int16_t HTON16(void *target, __nesc_nw_int16_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  return value;
}
static inline __nesc_nw_int32_t HTON32(void *target, __nesc_nw_int32_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  base[2] = value >> 16;
  base[3] = value >> 24;
  return value;
}
static inline __nesc_nw_int64_t HTON64(void *target, __nesc_nw_int64_t value) {
  unsigned char *base = target;
  base[0] = value;
  base[1] = value >> 8;
  base[2] = value >> 16;
  base[3] = value >> 24;
  base[4] = value >> 32;
  base[5] = value >> 40;
  base[6] = value >> 48;
  base[7] = value >> 56;
  return value;
}

#define dbg(mode, format, ...) ((void)0)
#define dbg_clear(mode, format, ...) ((void)0)
#define dbg_active(mode) 0
# 38 "/opt/msp430/msp430/include/sys/inttypes.h"
typedef signed char int8_t;
typedef unsigned char uint8_t;

typedef int int16_t;
typedef unsigned int uint16_t;

typedef long int32_t;
typedef unsigned long uint32_t;

typedef long long int64_t;
typedef unsigned long long uint64_t;




typedef int16_t intptr_t;
typedef uint16_t uintptr_t;
# 151 "/opt/msp430/lib/gcc-lib/msp430/3.2.3/include/stddef.h" 3
typedef int ptrdiff_t;
#line 213
typedef unsigned int size_t;
#line 325
typedef int wchar_t;
# 41 "/opt/msp430/msp430/include/sys/types.h"
typedef unsigned char u_char;
typedef unsigned short u_short;
typedef unsigned int u_int;
typedef unsigned long u_long;
typedef unsigned short ushort;
typedef unsigned int uint;

typedef uint8_t u_int8_t;
typedef uint16_t u_int16_t;
typedef uint32_t u_int32_t;
typedef uint64_t u_int64_t;

typedef u_int64_t u_quad_t;
typedef int64_t quad_t;
typedef quad_t *qaddr_t;

typedef char *caddr_t;
typedef const char *c_caddr_t;
typedef volatile char *v_caddr_t;
typedef u_int32_t fixpt_t;
typedef u_int32_t gid_t;
typedef u_int32_t in_addr_t;
typedef u_int16_t in_port_t;
typedef u_int32_t ino_t;
typedef long key_t;
typedef u_int16_t mode_t;
typedef u_int16_t nlink_t;
typedef quad_t rlim_t;
typedef int32_t segsz_t;
typedef int32_t swblk_t;
typedef int32_t ufs_daddr_t;
typedef int32_t ufs_time_t;
typedef u_int32_t uid_t;
# 64 "/opt/msp430/msp430/include/string.h"
extern void bzero(void *, size_t );
# 56 "/opt/msp430/msp430/include/stdlib.h"
typedef struct __nesc_unnamed4242 {
  int quot;
  int rem;
} div_t;




typedef struct __nesc_unnamed4243 {
  long quot;
  long rem;
} ldiv_t;
# 122 "/opt/msp430/msp430/include/sys/config.h" 3
typedef long int __int32_t;
typedef unsigned long int __uint32_t;
# 12 "/opt/msp430/msp430/include/sys/_types.h"
typedef long _off_t;
typedef long _ssize_t;
# 28 "/opt/msp430/msp430/include/sys/reent.h" 3
typedef __uint32_t __ULong;


struct _glue {

  struct _glue *_next;
  int _niobs;
  struct __sFILE *_iobs;
};

struct _Bigint {

  struct _Bigint *_next;
  int _k, _maxwds, _sign, _wds;
  __ULong _x[1];
};


struct __tm {

  int __tm_sec;
  int __tm_min;
  int __tm_hour;
  int __tm_mday;
  int __tm_mon;
  int __tm_year;
  int __tm_wday;
  int __tm_yday;
  int __tm_isdst;
};







struct _atexit {
  struct _atexit *_next;
  int _ind;
  void (*_fns[32])(void );
};








struct __sbuf {
  unsigned char *_base;
  int _size;
};






typedef long _fpos_t;
#line 116
struct __sFILE {
  unsigned char *_p;
  int _r;
  int _w;
  short _flags;
  short _file;
  struct __sbuf _bf;
  int _lbfsize;


  void *_cookie;

  int (*_read)(void *_cookie, char *_buf, int _n);
  int (*_write)(void *_cookie, const char *_buf, int _n);

  _fpos_t (*_seek)(void *_cookie, _fpos_t _offset, int _whence);
  int (*_close)(void *_cookie);


  struct __sbuf _ub;
  unsigned char *_up;
  int _ur;


  unsigned char _ubuf[3];
  unsigned char _nbuf[1];


  struct __sbuf _lb;


  int _blksize;
  int _offset;

  struct _reent *_data;
};
#line 174
struct _rand48 {
  unsigned short _seed[3];
  unsigned short _mult[3];
  unsigned short _add;
};









struct _reent {


  int _errno;




  struct __sFILE *_stdin, *_stdout, *_stderr;

  int _inc;
  char _emergency[25];

  int _current_category;
  const char *_current_locale;

  int __sdidinit;

  void (*__cleanup)(struct _reent *);


  struct _Bigint *_result;
  int _result_k;
  struct _Bigint *_p5s;
  struct _Bigint **_freelist;


  int _cvtlen;
  char *_cvtbuf;

  union __nesc_unnamed4244 {

    struct __nesc_unnamed4245 {

      unsigned int _unused_rand;
      char *_strtok_last;
      char _asctime_buf[26];
      struct __tm _localtime_buf;
      int _gamma_signgam;
      __extension__ unsigned long long _rand_next;
      struct _rand48 _r48;
    } _reent;



    struct __nesc_unnamed4246 {


      unsigned char *_nextf[30];
      unsigned int _nmalloc[30];
    } _unused;
  } _new;


  struct _atexit *_atexit;
  struct _atexit _atexit0;


  void (**_sig_func)(int );




  struct _glue __sglue;
  struct __sFILE __sf[3];
};
#line 273
struct _reent;
# 18 "/opt/msp430/msp430/include/math.h"
union __dmath {

  __uint32_t i[2];
  double d;
};




union __dmath;
#line 208
struct exception {


  int type;
  char *name;
  double arg1;
  double arg2;
  double retval;
  int err;
};
#line 261
enum __fdlibm_version {

  __fdlibm_ieee = -1, 
  __fdlibm_svid, 
  __fdlibm_xopen, 
  __fdlibm_posix
};




enum __fdlibm_version;
# 91 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/tos.h"
typedef unsigned char bool;






enum __nesc_unnamed4247 {
  FALSE = 0, 
  TRUE = 1
};



enum __nesc_unnamed4248 {
  FAIL = 0, 
  SUCCESS = 1
};
static inline 

uint8_t rcombine(uint8_t r1, uint8_t r2);
typedef uint8_t  result_t;
static inline 






result_t rcombine(result_t r1, result_t r2);
#line 140
enum __nesc_unnamed4249 {
  NULL = 0x0
};
# 27 "/opt/msp430/msp430/include/msp430/iostructures.h"
typedef union port {
  volatile unsigned char reg_p;
  volatile struct __nesc_unnamed4250 {
    unsigned char __p0 : 1, 
    __p1 : 1, 
    __p2 : 1, 
    __p3 : 1, 
    __p4 : 1, 
    __p5 : 1, 
    __p6 : 1, 
    __p7 : 1;
  } __pin;
} __attribute((packed))  ioregister_t;
# 106 "/opt/msp430/msp430/include/msp430/iostructures.h" 3
struct port_full_t {
  ioregister_t in;
  ioregister_t out;
  ioregister_t dir;
  ioregister_t ifg;
  ioregister_t ies;
  ioregister_t ie;
  ioregister_t sel;
};




struct port_simple_t {
  ioregister_t in;
  ioregister_t out;
  ioregister_t dir;
  ioregister_t sel;
};




struct port_full_t;



struct port_full_t;



struct port_simple_t;



struct port_simple_t;



struct port_simple_t;



struct port_simple_t;
# 103 "/opt/msp430/msp430/include/msp430/gpio.h" 3
volatile unsigned char P1OUT __asm ("0x0021");

volatile unsigned char P1DIR __asm ("0x0022");





volatile unsigned char P1IE __asm ("0x0025");

volatile unsigned char P1SEL __asm ("0x0026");






volatile unsigned char P2OUT __asm ("0x0029");

volatile unsigned char P2DIR __asm ("0x002A");





volatile unsigned char P2IE __asm ("0x002D");

volatile unsigned char P2SEL __asm ("0x002E");






volatile unsigned char P3OUT __asm ("0x0019");

volatile unsigned char P3DIR __asm ("0x001A");

volatile unsigned char P3SEL __asm ("0x001B");






volatile unsigned char P4OUT __asm ("0x001D");

volatile unsigned char P4DIR __asm ("0x001E");

volatile unsigned char P4SEL __asm ("0x001F");






volatile unsigned char P5OUT __asm ("0x0031");

volatile unsigned char P5DIR __asm ("0x0032");

volatile unsigned char P5SEL __asm ("0x0033");






volatile unsigned char P6OUT __asm ("0x0035");

volatile unsigned char P6DIR __asm ("0x0036");

volatile unsigned char P6SEL __asm ("0x0037");
# 87 "/opt/msp430/msp430/include/msp430/usart.h"
volatile unsigned char U0TCTL __asm ("0x0071");
#line 256
volatile unsigned char U1TCTL __asm ("0x0079");
# 22 "/opt/msp430/msp430/include/msp430/timera.h"
volatile unsigned int TA0IV __asm ("0x012E");

volatile unsigned int TA0CTL __asm ("0x0160");







volatile unsigned int TA0R __asm ("0x0170");
# 105 "/opt/msp430/msp430/include/msp430/timera.h" 3
typedef struct __nesc_unnamed4251 {
  volatile unsigned 
  taifg : 1, 
  taie : 1, 
  taclr : 1, 
  dummy : 1, 
  tamc : 2, 
  taid : 2, 
  tassel : 2;
} __attribute((packed))  tactl_t;

typedef struct __nesc_unnamed4252 {
  volatile unsigned 
  ccifg : 1, 
  cov : 1, 
  out : 1, 
  cci : 1, 
  ccie : 1, 
  outmod : 3, 
  cap : 1, 
  dummy : 1, 
  scci : 1, 
  scs : 1, 
  ccis : 2, 
  cm : 2;
} __attribute((packed))  tacctl_t;


struct timera_t {
  tactl_t ctl;
  tacctl_t cctl0;
  tacctl_t cctl1;
  tacctl_t cctl2;
  volatile unsigned dummy[4];
  volatile unsigned tar;
  volatile unsigned taccr0;
  volatile unsigned taccr1;
  volatile unsigned taccr2;
};



struct timera_t;
# 22 "/opt/msp430/msp430/include/msp430/timerb.h"
volatile unsigned int TBIV __asm ("0x011E");

volatile unsigned int TBCTL __asm ("0x0180");

volatile unsigned int TBCCTL0 __asm ("0x0182");





volatile unsigned int TBR __asm ("0x0190");

volatile unsigned int TBCCR0 __asm ("0x0192");
#line 63
typedef struct __nesc_unnamed4253 {
  volatile unsigned 
  tbifg : 1, 
  tbie : 1, 
  tbclr : 1, 
  dummy1 : 1, 
  tbmc : 2, 
  tbid : 2, 
  tbssel : 2, 
  dummy2 : 1, 
  tbcntl : 2, 
  tbclgrp : 2;
} __attribute((packed))  tbctl_t;

typedef struct __nesc_unnamed4254 {
  volatile unsigned 
  ccifg : 1, 
  cov : 1, 
  out : 1, 
  cci : 1, 
  ccie : 1, 
  outmod : 3, 
  cap : 1, 
  clld : 2, 
  scs : 1, 
  ccis : 2, 
  cm : 2;
} __attribute((packed))  tbcctl_t;


struct timerb_t {
  tbctl_t ctl;
  tbcctl_t cctl0;
  tbcctl_t cctl1;
  tbcctl_t cctl2;

  tbcctl_t cctl3;
  tbcctl_t cctl4;
  tbcctl_t cctl5;
  tbcctl_t cctl6;



  volatile unsigned tbr;
  volatile unsigned tbccr0;
  volatile unsigned tbccr1;
  volatile unsigned tbccr2;

  volatile unsigned tbccr3;
  volatile unsigned tbccr4;
  volatile unsigned tbccr5;
  volatile unsigned tbccr6;
};





struct timerb_t;
# 18 "/opt/msp430/msp430/include/msp430/basic_clock.h"
volatile unsigned char DCOCTL __asm ("0x0056");

volatile unsigned char BCSCTL1 __asm ("0x0057");

volatile unsigned char BCSCTL2 __asm ("0x0058");
# 18 "/opt/msp430/msp430/include/msp430/adc12.h"
volatile unsigned int ADC12CTL0 __asm ("0x01A0");

volatile unsigned int ADC12CTL1 __asm ("0x01A2");









typedef struct __nesc_unnamed4255 {
  volatile unsigned 
  adc12sc : 1, 
  enc : 1, 
  adc12tovie : 1, 
  adc12ovie : 1, 
  adc12on : 1, 
  refon : 1, 
  r2_5v : 1, 
  msc : 1, 
  sht0 : 4, 
  sht1 : 4;
} __attribute((packed))  adc12ctl0_t;

typedef struct __nesc_unnamed4256 {
  volatile unsigned 
  adc12busy : 1, 
  conseq : 2, 
  adc12ssel : 2, 
  adc12div : 3, 
  issh : 1, 
  shp : 1, 
  shs : 2, 
  cstartadd : 4;
} __attribute((packed))  adc12ctl1_t;

typedef struct __nesc_unnamed4257 {
  volatile unsigned 
  bit0 : 1, 
  bit1 : 1, 
  bit2 : 1, 
  bit3 : 1, 
  bit4 : 1, 
  bit5 : 1, 
  bit6 : 1, 
  bit7 : 1, 
  bit8 : 1, 
  bit9 : 1, 
  bit10 : 1, 
  bit11 : 1, 
  bit12 : 1, 
  bit13 : 1, 
  bit14 : 1, 
  bit15 : 1;
} __attribute((packed))  adc12xflg_t;


struct adc12_t {
  adc12ctl0_t ctl0;
  adc12ctl1_t ctl1;
  adc12xflg_t ifg;
  adc12xflg_t ie;
  adc12xflg_t iv;
};




struct adc12_t;
# 71 "/opt/msp430/msp430/include/msp430x16x.h"
volatile unsigned char ME1 __asm ("0x0004");





volatile unsigned char ME2 __asm ("0x0005");
 
# 148 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/msp430hardware.h"
static volatile uint8_t U0CTLnr __asm ("0x0070");
 static volatile uint8_t I2CTCTLnr __asm ("0x0071");
 static volatile uint8_t I2CDCTLnr __asm ("0x0072");
static 









__inline void TOSH_wait(void );
static 
#line 174
__inline void TOSH_uwait(uint16_t u);
static inline 
#line 196
void __nesc_disable_interrupt(void);
static inline 




void __nesc_enable_interrupt(void);
static inline 



bool are_interrupts_enabled(void);




typedef bool __nesc_atomic_t;
static inline 
__nesc_atomic_t __nesc_atomic_start(void );
static inline void __nesc_atomic_end(__nesc_atomic_t oldSreg);
static inline 


__nesc_atomic_t __nesc_atomic_start(void );
static inline 





void __nesc_atomic_end(__nesc_atomic_t reenable_interrupts);
 







bool LPMode_disabled = FALSE;
static 








__inline void __nesc_atomic_sleep(void);
# 105 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ADC12.h"
typedef struct __nesc_unnamed4258 {

  unsigned int refVolt2_5 : 1;
  unsigned int clockSourceSHT : 2;
  unsigned int clockSourceSAMPCON : 2;
  unsigned int clockDivSAMPCON : 2;
  unsigned int referenceVoltage : 3;
  unsigned int clockDivSHT : 3;
  unsigned int inputChannel : 4;
  unsigned int sampleHoldTime : 4;
  unsigned int  : 0;
} MSP430ADC12Settings_t;

typedef enum __nesc_unnamed4259 {

  MSP430ADC12_FAIL = 0, 
  MSP430ADC12_SUCCESS = 1, 
  MSP430ADC12_DELAYED = 2
} msp430ADCresult_t;

enum refVolt2_5_enum {

  REFVOLT_LEVEL_1_5 = 0, 
  REFVOLT_LEVEL_2_5 = 1
};

enum clockDivSHT_enum {

  SHT_CLOCK_DIV_1 = 0, 
  SHT_CLOCK_DIV_2 = 1, 
  SHT_CLOCK_DIV_3 = 2, 
  SHT_CLOCK_DIV_4 = 3, 
  SHT_CLOCK_DIV_5 = 4, 
  SHT_CLOCK_DIV_6 = 5, 
  SHT_CLOCK_DIV_7 = 6, 
  SHT_CLOCK_DIV_8 = 7
};

enum clockDivSAMPCON_enum {

  SAMPCON_CLOCK_DIV_1 = 0, 
  SAMPCON_CLOCK_DIV_2 = 1, 
  SAMPCON_CLOCK_DIV_3 = 2, 
  SAMPCON_CLOCK_DIV_4 = 3
};

enum clockSourceSAMPCON_enum {

  SAMPCON_SOURCE_TACLK = 0, 
  SAMPCON_SOURCE_ACLK = 1, 
  SAMPCON_SOURCE_SMCLK = 2, 
  SAMPCON_SOURCE_INCLK = 3
};

enum inputChannel_enum {


  INPUT_CHANNEL_A0 = 0, 
  INPUT_CHANNEL_A1 = 1, 
  INPUT_CHANNEL_A2 = 2, 
  INPUT_CHANNEL_A3 = 3, 
  INPUT_CHANNEL_A4 = 4, 
  INPUT_CHANNEL_A5 = 5, 
  INPUT_CHANNEL_A6 = 6, 
  INPUT_CHANNEL_A7 = 7, 
  EXTERNAL_REFERENCE_VOLTAGE = 8, 
  REFERENCE_VOLTAGE_NEGATIVE_TERMINAL = 9, 
  INTERNAL_TEMPERATURE = 10, 
  INTERNAL_VOLTAGE = 11
};

enum referenceVoltage_enum {

  REFERENCE_AVcc_AVss = 0, 
  REFERENCE_VREFplus_AVss = 1, 
  REFERENCE_VeREFplus_AVss = 2, 
  REFERENCE_AVcc_VREFnegterm = 4, 
  REFERENCE_VREFplus_VREFnegterm = 5, 
  REFERENCE_VeREFplus_VREFnegterm = 6
};

enum clockSourceSHT_enum {

  SHT_SOURCE_ADC12OSC = 0, 
  SHT_SOURCE_ACLK = 1, 
  SHT_SOURCE_MCLK = 2, 
  SHT_SOURCE_SMCLK = 3
};

enum sampleHold_enum {

  SAMPLE_HOLD_4_CYCLES = 0, 
  SAMPLE_HOLD_8_CYCLES = 1, 
  SAMPLE_HOLD_16_CYCLES = 2, 
  SAMPLE_HOLD_32_CYCLES = 3, 
  SAMPLE_HOLD_64_CYCLES = 4, 
  SAMPLE_HOLD_96_CYCLES = 5, 
  SAMPLE_HOLD_123_CYCLES = 6, 
  SAMPLE_HOLD_192_CYCLES = 7, 
  SAMPLE_HOLD_256_CYCLES = 8, 
  SAMPLE_HOLD_384_CYCLES = 9, 
  SAMPLE_HOLD_512_CYCLES = 10, 
  SAMPLE_HOLD_768_CYCLES = 11, 
  SAMPLE_HOLD_1024_CYCLES = 12
};






typedef union __nesc_unnamed4260 {
  uint32_t i;
  MSP430ADC12Settings_t s;
} MSP430ADC12Settings_ut;








enum __nesc_unnamed4261 {

  ADC_IDLE = 0, 
  SINGLE_CHANNEL = 1, 
  REPEAT_SINGLE_CHANNEL = 2, 
  SEQUENCE_OF_CHANNELS = 4, 
  REPEAT_SEQUENCE_OF_CHANNELS = 8, 
  TIMER_USED = 16, 
  RESERVED = 32, 
  VREF_WAIT = 64
};
#line 255
typedef struct __nesc_unnamed4262 {

  volatile unsigned 
  inch : 4, 
  sref : 3, 
  eos : 1;
} __attribute((packed))  adc12memctl_t;

typedef struct __nesc_unnamed4263 {

  unsigned int refVolt2_5 : 1;
  unsigned int gotRefVolt : 1;
  unsigned int result_16bit : 1;
  unsigned int clockSourceSHT : 2;
  unsigned int clockSourceSAMPCON : 2;
  unsigned int clockDivSAMPCON : 2;
  unsigned int clockDivSHT : 3;
  unsigned int sampleHoldTime : 4;
  adc12memctl_t memctl;
} __attribute((packed))  adc12settings_t;
# 58 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/lib/CC2420Radio/CC2420Const.h"
enum __nesc_unnamed4264 {
  CC2420_TIME_BIT = 4, 
  CC2420_TIME_BYTE = CC2420_TIME_BIT << 3, 
  CC2420_TIME_SYMBOL = 16
};
#line 76
enum __nesc_unnamed4265 {
  CC2420_MIN_CHANNEL = 11, 
  CC2420_MAX_CHANNEL = 26
};
#line 261
enum __nesc_unnamed4266 {
  CP_MAIN = 0, 
  CP_MDMCTRL0, 
  CP_MDMCTRL1, 
  CP_RSSI, 
  CP_SYNCWORD, 
  CP_TXCTRL, 
  CP_RXCTRL0, 
  CP_RXCTRL1, 
  CP_FSCTRL, 
  CP_SECCTRL0, 
  CP_SECCTRL1, 
  CP_BATTMON, 
  CP_IOCFG0, 
  CP_IOCFG1
};
# 46 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/telos/AM.h"
enum __nesc_unnamed4267 {
  TOS_BCAST_ADDR = 0xffff, 
  TOS_UART_ADDR = 0x007e
};





enum __nesc_unnamed4268 {
  TOS_DEFAULT_AM_GROUP = 0x7d
};
#line 71
typedef struct TOS_Msg {


  uint8_t length;
  uint8_t fcfhi;
  uint8_t fcflo;
  uint8_t dsn;
  uint16_t destpan;
  uint16_t addr;
  uint8_t type;
  uint8_t group;
  int8_t data[28];







  uint8_t strength;
  uint8_t lqi;
  bool crc;
  bool ack;
  uint16_t time;
} __attribute((packed))  TOS_Msg;

enum __nesc_unnamed4269 {

  MSG_HEADER_SIZE = (size_t )& ((struct TOS_Msg *)0)->data - 1, 

  MSG_FOOTER_SIZE = 2, 

  MSG_DATA_SIZE = (size_t )& ((struct TOS_Msg *)0)->strength + sizeof(uint16_t ), 

  DATA_LENGTH = 28, 

  LENGTH_BYTE_NUMBER = (size_t )& ((struct TOS_Msg *)0)->length + 1
};

typedef TOS_Msg *TOS_MsgPtr;
static inline 
# 35 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/telosb/hardware.h"
void TOSH_SET_SIMO0_PIN(void);
static inline 
#line 35
void TOSH_CLR_SIMO0_PIN(void);
static inline 
#line 35
void TOSH_MAKE_SIMO0_OUTPUT(void);
static inline 
#line 35
void TOSH_MAKE_SIMO0_INPUT(void);
static inline void TOSH_SET_UCLK0_PIN(void);
static inline 
#line 36
void TOSH_CLR_UCLK0_PIN(void);
static inline 
#line 36
void TOSH_MAKE_UCLK0_OUTPUT(void);
static inline 
#line 36
void TOSH_MAKE_UCLK0_INPUT(void);
static inline 
#line 71
void TOSH_SET_FLASH_CS_PIN(void);
static inline 
#line 71
void TOSH_CLR_FLASH_CS_PIN(void);
static inline 
#line 71
void TOSH_MAKE_FLASH_CS_OUTPUT(void);
static inline void TOSH_SET_FLASH_HOLD_PIN(void);
static inline 
#line 72
void TOSH_CLR_FLASH_HOLD_PIN(void);
static inline 
#line 72
void TOSH_MAKE_FLASH_HOLD_OUTPUT(void);
static inline 









void TOSH_FLASH_M25P_DP_bit(bool set);
static inline 









void TOSH_FLASH_M25P_DP(void);
static inline 
#line 129
void TOSH_SET_PIN_DIRECTIONS(void );
# 54 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/types/dbg_modes.h"
typedef long long TOS_dbg_mode;



enum __nesc_unnamed4270 {
  DBG_ALL = ~0ULL, 


  DBG_BOOT = 1ULL << 0, 
  DBG_CLOCK = 1ULL << 1, 
  DBG_TASK = 1ULL << 2, 
  DBG_SCHED = 1ULL << 3, 
  DBG_SENSOR = 1ULL << 4, 
  DBG_LED = 1ULL << 5, 
  DBG_CRYPTO = 1ULL << 6, 


  DBG_ROUTE = 1ULL << 7, 
  DBG_AM = 1ULL << 8, 
  DBG_CRC = 1ULL << 9, 
  DBG_PACKET = 1ULL << 10, 
  DBG_ENCODE = 1ULL << 11, 
  DBG_RADIO = 1ULL << 12, 


  DBG_LOG = 1ULL << 13, 
  DBG_ADC = 1ULL << 14, 
  DBG_I2C = 1ULL << 15, 
  DBG_UART = 1ULL << 16, 
  DBG_PROG = 1ULL << 17, 
  DBG_SOUNDER = 1ULL << 18, 
  DBG_TIME = 1ULL << 19, 
  DBG_POWER = 1ULL << 20, 



  DBG_SIM = 1ULL << 21, 
  DBG_QUEUE = 1ULL << 22, 
  DBG_SIMRADIO = 1ULL << 23, 
  DBG_HARD = 1ULL << 24, 
  DBG_MEM = 1ULL << 25, 



  DBG_USR1 = 1ULL << 27, 
  DBG_USR2 = 1ULL << 28, 
  DBG_USR3 = 1ULL << 29, 
  DBG_TEMP = 1ULL << 30, 

  DBG_ERROR = 1ULL << 31, 
  DBG_NONE = 0, 

  DBG_DEFAULT = DBG_ALL
};
# 59 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/sched.c"
typedef struct __nesc_unnamed4271 {
  void (*tp)(void);
} TOSH_sched_entry_T;

enum __nesc_unnamed4272 {






  TOSH_MAX_TASKS = 8, 

  TOSH_TASK_BITMASK = TOSH_MAX_TASKS - 1
};

volatile TOSH_sched_entry_T TOSH_queue[TOSH_MAX_TASKS];
uint8_t TOSH_sched_full;
volatile uint8_t TOSH_sched_free;
static inline 
void TOSH_sched_init(void );








bool TOS_post(void (*tp)(void));
#line 102
bool  TOS_post(void (*tp)(void));
static inline 
#line 136
bool TOSH_run_next_task(void);
static inline 
#line 159
void TOSH_run_task(void);
# 28 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/Ident.h"
enum __nesc_unnamed4273 {

  IDENT_MAX_PROGRAM_NAME_LENGTH = 16
};

typedef struct __nesc_unnamed4274 {

  uint32_t unix_time;
  uint32_t user_hash;
  char program_name[IDENT_MAX_PROGRAM_NAME_LENGTH];
} Ident_t;
# 28 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.h"
enum __nesc_unnamed4275 {
  MSP430TIMER_CM_NONE = 0, 
  MSP430TIMER_CM_RISING = 1, 
  MSP430TIMER_CM_FALLING = 2, 
  MSP430TIMER_CM_BOTH = 3, 

  MSP430TIMER_STOP_MODE = 0, 
  MSP430TIMER_UP_MODE = 1, 
  MSP430TIMER_CONTINUOUS_MODE = 2, 
  MSP430TIMER_UPDOWN_MODE = 3, 

  MSP430TIMER_TACLK = 0, 
  MSP430TIMER_TBCLK = 0, 
  MSP430TIMER_ACLK = 1, 
  MSP430TIMER_SMCLK = 2, 
  MSP430TIMER_INCLK = 3, 

  MSP430TIMER_CLOCKDIV_1 = 0, 
  MSP430TIMER_CLOCKDIV_2 = 1, 
  MSP430TIMER_CLOCKDIV_4 = 2, 
  MSP430TIMER_CLOCKDIV_8 = 3
};

typedef struct __nesc_unnamed4276 {

  int ccifg : 1;
  int cov : 1;
  int out : 1;
  int cci : 1;
  int ccie : 1;
  int outmod : 3;
  int cap : 1;
  int clld : 2;
  int scs : 1;
  int ccis : 2;
  int cm : 2;
} MSP430CompareControl_t;

typedef struct __nesc_unnamed4277 {

  int taifg : 1;
  int taie : 1;
  int taclr : 1;
  int _unused0 : 1;
  int mc : 2;
  int id : 2;
  int tassel : 2;
  int _unused1 : 6;
} MSP430TimerAControl_t;

typedef struct __nesc_unnamed4278 {

  int tbifg : 1;
  int tbie : 1;
  int tbclr : 1;
  int _unused0 : 1;
  int mc : 2;
  int id : 2;
  int tbssel : 2;
  int _unused1 : 1;
  int cntl : 2;
  int tbclgrp : 2;
  int _unused2 : 1;
} MSP430TimerBControl_t;
# 39 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/Timer.h"
enum __nesc_unnamed4279 {
  TIMER_REPEAT = 0, 
  TIMER_ONE_SHOT = 1, 
  NUM_TIMERS = 1
};
static  result_t HPLInitM$init(void);
static  void MSP430ClockM$MSP430ClockInit$default$initTimerB(void);
static  void MSP430ClockM$MSP430ClockInit$defaultInitTimerA(void);
static  void MSP430ClockM$MSP430ClockInit$default$initTimerA(void);
static  void MSP430ClockM$MSP430ClockInit$defaultInitTimerB(void);
static  void MSP430ClockM$MSP430ClockInit$default$initClocks(void);
static  void MSP430ClockM$MSP430ClockInit$defaultInitClocks(void);
static  result_t MSP430ClockM$StdControl$init(void);
static  result_t MSP430ClockM$StdControl$start(void);
static   void MSP430DCOCalibM$Timer32khz$overflow(void);
static   void MSP430DCOCalibM$TimerMicro$overflow(void);
static   MSP430CompareControl_t MSP430TimerM$ControlA2$getControl(void);
static   MSP430CompareControl_t MSP430TimerM$ControlB0$getControl(void);
static   uint16_t MSP430TimerM$CaptureA1$getEvent(void);
static   void MSP430TimerM$CaptureA1$default$captured(uint16_t arg_0x8995108);
static   uint16_t MSP430TimerM$CaptureB3$getEvent(void);
static   void MSP430TimerM$CaptureB3$default$captured(uint16_t arg_0x8995108);
static   void MSP430TimerM$CompareA1$default$fired(void);
static   void MSP430TimerM$CompareB3$setEventFromNow(uint16_t arg_0x8959668);
static   uint16_t MSP430TimerM$CaptureB6$getEvent(void);
static   void MSP430TimerM$CaptureB6$default$captured(uint16_t arg_0x8995108);
static   MSP430CompareControl_t MSP430TimerM$ControlB4$getControl(void);
static   MSP430CompareControl_t MSP430TimerM$ControlA0$getControl(void);
static   uint16_t MSP430TimerM$CaptureB1$getEvent(void);
static   void MSP430TimerM$CaptureB1$default$captured(uint16_t arg_0x8995108);
static   void MSP430TimerM$CompareB1$default$fired(void);
static   MSP430CompareControl_t MSP430TimerM$ControlB1$getControl(void);
static   uint16_t MSP430TimerM$CaptureA2$getEvent(void);
static   void MSP430TimerM$CaptureA2$default$captured(uint16_t arg_0x8995108);
static   uint16_t MSP430TimerM$CaptureB4$getEvent(void);
static   void MSP430TimerM$CaptureB4$default$captured(uint16_t arg_0x8995108);
static   MSP430CompareControl_t MSP430TimerM$ControlB2$getControl(void);
static   void MSP430TimerM$CompareA2$default$fired(void);
static   void MSP430TimerM$CompareB4$default$fired(void);
static   MSP430CompareControl_t MSP430TimerM$ControlA1$getControl(void);
static   MSP430CompareControl_t MSP430TimerM$ControlB5$getControl(void);
static   uint16_t MSP430TimerM$CaptureA0$getEvent(void);
static   void MSP430TimerM$CaptureA0$default$captured(uint16_t arg_0x8995108);
static   uint16_t MSP430TimerM$CaptureB2$getEvent(void);
static   void MSP430TimerM$CaptureB2$default$captured(uint16_t arg_0x8995108);
static   void MSP430TimerM$CompareA0$default$fired(void);
static   void MSP430TimerM$CompareB2$default$fired(void);
static   uint16_t MSP430TimerM$CaptureB5$getEvent(void);
static   void MSP430TimerM$CaptureB5$default$captured(uint16_t arg_0x8995108);
static   MSP430CompareControl_t MSP430TimerM$ControlB3$getControl(void);
static   void MSP430TimerM$ControlB3$enableEvents(void);
static   void MSP430TimerM$ControlB3$setControlAsCompare(void);
static   void MSP430TimerM$ControlB3$disableEvents(void);
static   void MSP430TimerM$ControlB3$clearPendingInterrupt(void);
static   uint16_t MSP430TimerM$TimerB$read(void);
static   bool MSP430TimerM$TimerB$isOverflowPending(void);
static   void MSP430TimerM$CompareB5$default$fired(void);
static   uint16_t MSP430TimerM$CaptureB0$getEvent(void);
static   void MSP430TimerM$CaptureB0$default$captured(uint16_t arg_0x8995108);
static   void MSP430TimerM$CompareB6$default$fired(void);
static   void MSP430TimerM$CompareB0$default$fired(void);
static   MSP430CompareControl_t MSP430TimerM$ControlB6$getControl(void);
static  result_t BlinkM$StdControl$init(void);
static  result_t BlinkM$StdControl$start(void);
static  result_t BlinkM$Timer$fired(void);
static  result_t TimerM$TimerMilli$default$fired(uint8_t arg_0x8a8f608);
static   uint32_t TimerM$LocalTime$read(void);
static   void TimerM$AlarmCompare$fired(void);
static  result_t TimerM$TimerJiffy$default$fired(uint8_t arg_0x8a60010);
static   void TimerM$AlarmTimer$overflow(void);
static  result_t TimerM$StdControl$init(void);
static  result_t TimerM$StdControl$start(void);
static  result_t TimerM$Timer$default$fired(uint8_t arg_0x8a8ef80);
static  result_t TimerM$Timer$start(uint8_t arg_0x8a8ef80, char arg_0x8a66558, uint32_t arg_0x8a666b0);
static  
# 47 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MainM.nc"
result_t MainM$hardwareInit(void);
static  
# 63 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
result_t MainM$StdControl$init(void);
static  





result_t MainM$StdControl$start(void);
# 52 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MainM.nc"
int   main(void);
static  
# 63 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
result_t HPLInitM$MSP430ClockControl$init(void);
static  





result_t HPLInitM$MSP430ClockControl$start(void);
static inline  
# 35 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/HPLInitM.nc"
result_t HPLInitM$init(void);
static  
# 29 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockInit.nc"
void MSP430ClockM$MSP430ClockInit$initTimerB(void);
static  
#line 28
void MSP430ClockM$MSP430ClockInit$initTimerA(void);
static  
#line 27
void MSP430ClockM$MSP430ClockInit$initClocks(void);
 
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
static volatile uint8_t MSP430ClockM$IE1 __asm ("0x0000");
 static volatile uint16_t MSP430ClockM$TA0CTL __asm ("0x0160");
 static volatile uint16_t MSP430ClockM$TA0IV __asm ("0x012E");
 static volatile uint16_t MSP430ClockM$TBCTL __asm ("0x0180");
 static volatile uint16_t MSP430ClockM$TBIV __asm ("0x011E");

enum MSP430ClockM$__nesc_unnamed4280 {

  MSP430ClockM$ACLK_CALIB_PERIOD = 8, 
  MSP430ClockM$ACLK_KHZ = 32, 
  MSP430ClockM$TARGET_DCO_KHZ = 4096, 
  MSP430ClockM$TARGET_DCO_DELTA = MSP430ClockM$TARGET_DCO_KHZ / MSP430ClockM$ACLK_KHZ * MSP430ClockM$ACLK_CALIB_PERIOD
};
static inline  
void MSP430ClockM$MSP430ClockInit$defaultInitClocks(void);
static inline  
#line 69
void MSP430ClockM$MSP430ClockInit$defaultInitTimerA(void);
static inline  
#line 84
void MSP430ClockM$MSP430ClockInit$defaultInitTimerB(void);
static inline   
#line 99
void MSP430ClockM$MSP430ClockInit$default$initClocks(void);
static inline   



void MSP430ClockM$MSP430ClockInit$default$initTimerA(void);
static inline   



void MSP430ClockM$MSP430ClockInit$default$initTimerB(void);
static inline 




void MSP430ClockM$startTimerA(void);
static inline 
#line 127
void MSP430ClockM$startTimerB(void);
static 
#line 139
void MSP430ClockM$set_dco_calib(int calib);
static inline 




uint16_t MSP430ClockM$test_calib_busywait_delta(int calib);
static inline 
#line 168
void MSP430ClockM$busyCalibrateDCO(void);
static inline  
#line 201
result_t MSP430ClockM$StdControl$init(void);
static inline  
#line 220
result_t MSP430ClockM$StdControl$start(void);
static   
# 30 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
uint16_t MSP430DCOCalibM$Timer32khz$read(void);
# 32 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430DCOCalibM.nc"
uint16_t MSP430DCOCalibM$m_prev;

enum MSP430DCOCalibM$__nesc_unnamed4281 {

  MSP430DCOCalibM$TARGET_DELTA = 2048, 
  MSP430DCOCalibM$MAX_DEVIATION = 7
};
static inline   

void MSP430DCOCalibM$TimerMicro$overflow(void);
static inline   
#line 75
void MSP430DCOCalibM$Timer32khz$overflow(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureA1$captured(uint16_t arg_0x8995108);
static   
#line 74
void MSP430TimerM$CaptureB3$captured(uint16_t arg_0x8995108);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareA1$fired(void);
static   
#line 34
void MSP430TimerM$CompareB3$fired(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureB6$captured(uint16_t arg_0x8995108);
static   
#line 74
void MSP430TimerM$CaptureB1$captured(uint16_t arg_0x8995108);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareB1$fired(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureA2$captured(uint16_t arg_0x8995108);
static   
#line 74
void MSP430TimerM$CaptureB4$captured(uint16_t arg_0x8995108);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareA2$fired(void);
static   
# 33 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
void MSP430TimerM$TimerA$overflow(void);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareB4$fired(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureA0$captured(uint16_t arg_0x8995108);
static   
#line 74
void MSP430TimerM$CaptureB2$captured(uint16_t arg_0x8995108);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareA0$fired(void);
static   
#line 34
void MSP430TimerM$CompareB2$fired(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureB5$captured(uint16_t arg_0x8995108);
static   
# 33 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
void MSP430TimerM$TimerB$overflow(void);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareB5$fired(void);
static   
# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
void MSP430TimerM$CaptureB0$captured(uint16_t arg_0x8995108);
static   
# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void MSP430TimerM$CompareB6$fired(void);
static   
#line 34
void MSP430TimerM$CompareB0$fired(void);
 
# 69 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
static volatile uint16_t MSP430TimerM$TA0CCTL0 __asm ("0x0162");
 static volatile uint16_t MSP430TimerM$TA0CCTL1 __asm ("0x0164");
 static volatile uint16_t MSP430TimerM$TA0CCTL2 __asm ("0x0166");
 
static volatile uint16_t MSP430TimerM$TA0CCR0 __asm ("0x0172");
 static volatile uint16_t MSP430TimerM$TA0CCR1 __asm ("0x0174");
 static volatile uint16_t MSP430TimerM$TA0CCR2 __asm ("0x0176");
 
static volatile uint16_t MSP430TimerM$TBCCTL0 __asm ("0x0182");
 static volatile uint16_t MSP430TimerM$TBCCTL1 __asm ("0x0184");
 static volatile uint16_t MSP430TimerM$TBCCTL2 __asm ("0x0186");
 static volatile uint16_t MSP430TimerM$TBCCTL3 __asm ("0x0188");
 static volatile uint16_t MSP430TimerM$TBCCTL4 __asm ("0x018A");
 static volatile uint16_t MSP430TimerM$TBCCTL5 __asm ("0x018C");
 static volatile uint16_t MSP430TimerM$TBCCTL6 __asm ("0x018E");
 
static volatile uint16_t MSP430TimerM$TBCCR0 __asm ("0x0192");
 static volatile uint16_t MSP430TimerM$TBCCR1 __asm ("0x0194");
 static volatile uint16_t MSP430TimerM$TBCCR2 __asm ("0x0196");
 static volatile uint16_t MSP430TimerM$TBCCR3 __asm ("0x0198");
 static volatile uint16_t MSP430TimerM$TBCCR4 __asm ("0x019A");
 static volatile uint16_t MSP430TimerM$TBCCR5 __asm ("0x019C");
 static volatile uint16_t MSP430TimerM$TBCCR6 __asm ("0x019E");

typedef MSP430CompareControl_t MSP430TimerM$CC_t;
static inline 
uint16_t MSP430TimerM$CC2int(MSP430TimerM$CC_t x);
static inline MSP430TimerM$CC_t MSP430TimerM$int2CC(uint16_t x);
static inline 
uint16_t MSP430TimerM$compareControl(void);
#line 123
void __attribute((interrupt(12))) __attribute((wakeup))  sig_TIMERA0_VECTOR(void);







void __attribute((interrupt(10))) __attribute((wakeup))  sig_TIMERA1_VECTOR(void);
static inline    
#line 157
void MSP430TimerM$CompareA0$default$fired(void);
static inline    void MSP430TimerM$CompareA1$default$fired(void);
static inline    void MSP430TimerM$CompareA2$default$fired(void);
static inline    void MSP430TimerM$CaptureA0$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureA1$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureA2$default$captured(uint16_t time);
static inline   


uint16_t MSP430TimerM$TimerB$read(void);
static inline   

bool MSP430TimerM$TimerB$isOverflowPending(void);
static inline   
#line 205
MSP430TimerM$CC_t MSP430TimerM$ControlA0$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlA1$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlA2$getControl(void);
static inline   
#line 253
uint16_t MSP430TimerM$CaptureA0$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureA1$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureA2$getEvent(void);
#line 277
void __attribute((interrupt(26))) __attribute((wakeup))  sig_TIMERB0_VECTOR(void);







void __attribute((interrupt(24))) __attribute((wakeup))  sig_TIMERB1_VECTOR(void);
static inline    
#line 331
void MSP430TimerM$CompareB0$default$fired(void);
static inline    void MSP430TimerM$CompareB1$default$fired(void);
static inline    void MSP430TimerM$CompareB2$default$fired(void);
static inline    
void MSP430TimerM$CompareB4$default$fired(void);
static inline    void MSP430TimerM$CompareB5$default$fired(void);
static inline    void MSP430TimerM$CompareB6$default$fired(void);
static inline    void MSP430TimerM$CaptureB0$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB1$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB2$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB3$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB4$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB5$default$captured(uint16_t time);
static inline    void MSP430TimerM$CaptureB6$default$captured(uint16_t time);
static inline   

MSP430TimerM$CC_t MSP430TimerM$ControlB0$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB1$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB2$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB3$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB4$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB5$getControl(void);
static inline   MSP430TimerM$CC_t MSP430TimerM$ControlB6$getControl(void);
static inline   
#line 366
void MSP430TimerM$ControlB3$clearPendingInterrupt(void);
static inline   
#line 382
void MSP430TimerM$ControlB3$setControlAsCompare(void);
static inline   
#line 414
void MSP430TimerM$ControlB3$enableEvents(void);
static inline   






void MSP430TimerM$ControlB3$disableEvents(void);
static inline   
#line 443
uint16_t MSP430TimerM$CaptureB0$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB1$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB2$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB3$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB4$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB5$getEvent(void);
static inline   uint16_t MSP430TimerM$CaptureB6$getEvent(void);
static inline   
#line 470
void MSP430TimerM$CompareB3$setEventFromNow(uint16_t x);
static  
# 59 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/Timer.nc"
result_t BlinkM$Timer$start(char arg_0x8a66558, uint32_t arg_0x8a666b0);
# 47 "BlinkM.nc"
int BlinkM$count = 0;
static inline  
result_t BlinkM$StdControl$init(void);
static inline  









result_t BlinkM$StdControl$start(void);
static inline  
#line 81
result_t BlinkM$Timer$fired(void);
static  
# 37 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerMilli.nc"
result_t TimerM$TimerMilli$fired(
# 32 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
uint8_t arg_0x8a8f608);
static   
# 38 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerControl.nc"
void TimerM$AlarmControl$enableEvents(void);
static   
#line 35
void TimerM$AlarmControl$setControlAsCompare(void);
static   


void TimerM$AlarmControl$disableEvents(void);
static   
#line 32
void TimerM$AlarmControl$clearPendingInterrupt(void);
static   
# 32 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
void TimerM$AlarmCompare$setEventFromNow(uint16_t arg_0x8959668);
static  
# 37 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerJiffy.nc"
result_t TimerM$TimerJiffy$fired(
# 33 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
uint8_t arg_0x8a60010);
static   
# 30 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
uint16_t TimerM$AlarmTimer$read(void);
static   bool TimerM$AlarmTimer$isOverflowPending(void);
static  
# 73 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/Timer.nc"
result_t TimerM$Timer$fired(
# 31 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
uint8_t arg_0x8a8ef80);








enum TimerM$__nesc_unnamed4282 {

  TimerM$COUNT_TIMER_OLD = 1, 
  TimerM$COUNT_TIMER_MILLI = 0, 
  TimerM$COUNT_TIMER_JIFFY = 0, 

  TimerM$OFFSET_TIMER_OLD = 0, 
  TimerM$OFFSET_TIMER_MILLI = TimerM$OFFSET_TIMER_OLD + TimerM$COUNT_TIMER_OLD, 
  TimerM$OFFSET_TIMER_JIFFY = TimerM$OFFSET_TIMER_MILLI + TimerM$COUNT_TIMER_MILLI, 
  TimerM$NUM_TIMERS = TimerM$OFFSET_TIMER_JIFFY + TimerM$COUNT_TIMER_JIFFY, 

  TimerM$EMPTY_LIST = 255
};

typedef struct TimerM$Timer_s {

  uint32_t alarm;
  uint8_t next;
  bool isperiodic : 1;
  bool isset : 1;
  bool isqueued : 1;
  int _reserved_flags : 5;
  uint8_t _reserved_byte;
} TimerM$Timer_t;

TimerM$Timer_t TimerM$m_timers[TimerM$NUM_TIMERS];
int32_t TimerM$m_period[TimerM$NUM_TIMERS];
uint16_t TimerM$m_hinow;
uint8_t TimerM$m_head_short;
uint8_t TimerM$m_head_long;
bool TimerM$m_posted_checkShortTimers;
static inline  
result_t TimerM$StdControl$init(void);
static inline  
#line 84
result_t TimerM$StdControl$start(void);
static 








void TimerM$insertTimer(uint8_t num, bool isshort);
static inline 
#line 113
void TimerM$removeTimer(uint8_t num);
static inline 



void TimerM$signal_timer_fired(uint8_t num);
static 
#line 141
void TimerM$executeTimers(uint8_t head);
static inline  
#line 184
void TimerM$checkShortTimers(void);
static inline 
void TimerM$post_checkShortTimers(void);
static 
#line 198
void TimerM$setNextShortEvent(void);
static inline  
#line 257
void TimerM$checkShortTimers(void);
static inline  







void TimerM$checkLongTimers(void);
static 







uint16_t TimerM$readTime(void);
static   
#line 288
uint32_t TimerM$LocalTime$read(void);
static inline   
#line 308
void TimerM$AlarmCompare$fired(void);
static inline   



void TimerM$AlarmTimer$overflow(void);
static 




result_t TimerM$setTimer(uint8_t num, int32_t jiffy, bool isperiodic);
static inline   
#line 386
result_t TimerM$TimerJiffy$default$fired(uint8_t num);
static inline   
#line 435
result_t TimerM$TimerMilli$default$fired(uint8_t num);
static inline  






result_t TimerM$Timer$start(uint8_t num, char type, uint32_t milli);
static inline   
#line 463
result_t TimerM$Timer$default$fired(uint8_t num);
static inline 
# 127 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
void MSP430ClockM$startTimerB(void)
{

  MSP430ClockM$TBCTL = 0x0020 | (MSP430ClockM$TBCTL & ~(0x0020 | 0x0010));
}

static inline 
#line 115
void MSP430ClockM$startTimerA(void)
{

  MSP430ClockM$TA0CTL = 0x0020 | (MSP430ClockM$TA0CTL & ~(0x0020 | 0x0010));
}

static inline  
#line 220
result_t MSP430ClockM$StdControl$start(void)
{
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {
      MSP430ClockM$startTimerA();
      MSP430ClockM$startTimerB();
    }
#line 226
    __nesc_atomic_end(__nesc_atomic); }
  return SUCCESS;
}

# 70 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
inline static  result_t HPLInitM$MSP430ClockControl$start(void){
#line 70
  unsigned char result;
#line 70

#line 70
  result = MSP430ClockM$StdControl$start();
#line 70

#line 70
  return result;
#line 70
}
#line 70
static inline  
# 84 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
void MSP430ClockM$MSP430ClockInit$defaultInitTimerB(void)
{
  TBR = 0;









  MSP430ClockM$TBCTL = 0x0100 | 0x0002;
}

static inline   









void MSP430ClockM$MSP430ClockInit$default$initTimerB(void)
{
  MSP430ClockM$MSP430ClockInit$defaultInitTimerB();
}

# 29 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockInit.nc"
inline static  void MSP430ClockM$MSP430ClockInit$initTimerB(void){
#line 29
  MSP430ClockM$MSP430ClockInit$default$initTimerB();
#line 29
}
#line 29
static inline  
# 69 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
void MSP430ClockM$MSP430ClockInit$defaultInitTimerA(void)
{
  TA0R = 0;









  MSP430ClockM$TA0CTL = 0x0200 | 0x0002;
}

static inline   
#line 104
void MSP430ClockM$MSP430ClockInit$default$initTimerA(void)
{
  MSP430ClockM$MSP430ClockInit$defaultInitTimerA();
}

# 28 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockInit.nc"
inline static  void MSP430ClockM$MSP430ClockInit$initTimerA(void){
#line 28
  MSP430ClockM$MSP430ClockInit$default$initTimerA();
#line 28
}
#line 28
static inline  
# 48 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
void MSP430ClockM$MSP430ClockInit$defaultInitClocks(void)
{





  BCSCTL1 = 0x80 | (BCSCTL1 & ((0x04 | 0x02) | 0x01));







  BCSCTL2 = 0x04;


  MSP430ClockM$IE1 &= ~(1 << 1);
}

static inline   
#line 99
void MSP430ClockM$MSP430ClockInit$default$initClocks(void)
{
  MSP430ClockM$MSP430ClockInit$defaultInitClocks();
}

# 27 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockInit.nc"
inline static  void MSP430ClockM$MSP430ClockInit$initClocks(void){
#line 27
  MSP430ClockM$MSP430ClockInit$default$initClocks();
#line 27
}
#line 27
static inline 
# 145 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
uint16_t MSP430ClockM$test_calib_busywait_delta(int calib)
{
  int8_t aclk_count = 2;
  uint16_t dco_prev = 0;
  uint16_t dco_curr = 0;

  MSP430ClockM$set_dco_calib(calib);

  while (aclk_count-- > 0) 
    {
      TBCCR0 = TBR + MSP430ClockM$ACLK_CALIB_PERIOD;
      TBCCTL0 &= ~0x0001;
      while ((TBCCTL0 & 0x0001) == 0) ;
      dco_prev = dco_curr;
      dco_curr = TA0R;
    }

  return dco_curr - dco_prev;
}

static inline 


void MSP430ClockM$busyCalibrateDCO(void)
{

  int calib;
  int step;



  MSP430ClockM$TA0CTL = 0x0200 | 0x0020;
  MSP430ClockM$TBCTL = 0x0100 | 0x0020;
  BCSCTL1 = 0x80 | 0x04;
  BCSCTL2 = 0;
  TBCCTL0 = 0x4000;






  for (calib = 0, step = 0x800; step != 0; step >>= 1) 
    {

      if (MSP430ClockM$test_calib_busywait_delta(calib | step) <= MSP430ClockM$TARGET_DCO_DELTA) {
        calib |= step;
        }
    }

  if ((calib & 0x0e0) == 0x0e0) {
    calib &= ~0x01f;
    }
  MSP430ClockM$set_dco_calib(calib);
}

static inline  result_t MSP430ClockM$StdControl$init(void)
{

  MSP430ClockM$TA0CTL = 0x0004;
  MSP430ClockM$TA0IV = 0;
  MSP430ClockM$TBCTL = 0x0004;
  MSP430ClockM$TBIV = 0;

  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {
      MSP430ClockM$busyCalibrateDCO();
      MSP430ClockM$MSP430ClockInit$initClocks();
      MSP430ClockM$MSP430ClockInit$initTimerA();
      MSP430ClockM$MSP430ClockInit$initTimerB();
    }
#line 215
    __nesc_atomic_end(__nesc_atomic); }

  return SUCCESS;
}

# 63 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
inline static  result_t HPLInitM$MSP430ClockControl$init(void){
#line 63
  unsigned char result;
#line 63

#line 63
  result = MSP430ClockM$StdControl$init();
#line 63

#line 63
  return result;
#line 63
}
#line 63
static inline 
# 72 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/telosb/hardware.h"
void TOSH_CLR_FLASH_HOLD_PIN(void)
#line 72
{
   
#line 72
  static volatile uint8_t r __asm ("0x001D");

#line 72
  r &= ~(1 << 7);
}

static inline 
#line 36
void TOSH_MAKE_UCLK0_INPUT(void)
#line 36
{
   
#line 36
  static volatile uint8_t r __asm ("0x001A");

#line 36
  r &= ~(1 << 3);
}

static inline 
#line 35
void TOSH_MAKE_SIMO0_INPUT(void)
#line 35
{
   
#line 35
  static volatile uint8_t r __asm ("0x001A");

#line 35
  r &= ~(1 << 1);
}

static inline 
#line 35
void TOSH_SET_SIMO0_PIN(void)
#line 35
{
   
#line 35
  static volatile uint8_t r __asm ("0x0019");

#line 35
  r |= 1 << 1;
}

static inline 
#line 71
void TOSH_SET_FLASH_CS_PIN(void)
#line 71
{
   
#line 71
  static volatile uint8_t r __asm ("0x001D");

#line 71
  r |= 1 << 4;
}

static inline 
#line 36
void TOSH_CLR_UCLK0_PIN(void)
#line 36
{
   
#line 36
  static volatile uint8_t r __asm ("0x0019");

#line 36
  r &= ~(1 << 3);
}

static inline 
#line 36
void TOSH_SET_UCLK0_PIN(void)
#line 36
{
   
#line 36
  static volatile uint8_t r __asm ("0x0019");

#line 36
  r |= 1 << 3;
}

static inline 
#line 35
void TOSH_CLR_SIMO0_PIN(void)
#line 35
{
   
#line 35
  static volatile uint8_t r __asm ("0x0019");

#line 35
  r &= ~(1 << 1);
}

static inline 
#line 83
void TOSH_FLASH_M25P_DP_bit(bool set)
#line 83
{
  if (set) {
    TOSH_SET_SIMO0_PIN();
    }
  else {
#line 87
    TOSH_CLR_SIMO0_PIN();
    }
#line 88
  TOSH_SET_UCLK0_PIN();
  TOSH_CLR_UCLK0_PIN();
}

static inline 
#line 71
void TOSH_CLR_FLASH_CS_PIN(void)
#line 71
{
   
#line 71
  static volatile uint8_t r __asm ("0x001D");

#line 71
  r &= ~(1 << 4);
}

static 
# 161 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/msp430hardware.h"
__inline void TOSH_wait(void )
{
   __asm volatile ("nop");
	__asm volatile ("nop");
}

static inline 
# 72 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/telosb/hardware.h"
void TOSH_SET_FLASH_HOLD_PIN(void)
#line 72
{
   
#line 72
  static volatile uint8_t r __asm ("0x001D");

#line 72
  r |= 1 << 7;
}

static inline 
#line 71
void TOSH_MAKE_FLASH_CS_OUTPUT(void)
#line 71
{
   
#line 71
  static volatile uint8_t r __asm ("0x001E");

#line 71
  r |= 1 << 4;
}

static inline 
#line 72
void TOSH_MAKE_FLASH_HOLD_OUTPUT(void)
#line 72
{
   
#line 72
  static volatile uint8_t r __asm ("0x001E");

#line 72
  r |= 1 << 7;
}

static inline 
#line 36
void TOSH_MAKE_UCLK0_OUTPUT(void)
#line 36
{
   
#line 36
  static volatile uint8_t r __asm ("0x001A");

#line 36
  r |= 1 << 3;
}

static inline 
#line 35
void TOSH_MAKE_SIMO0_OUTPUT(void)
#line 35
{
   
#line 35
  static volatile uint8_t r __asm ("0x001A");

#line 35
  r |= 1 << 1;
}

static inline 
#line 94
void TOSH_FLASH_M25P_DP(void)
#line 94
{

  TOSH_MAKE_SIMO0_OUTPUT();
  TOSH_MAKE_UCLK0_OUTPUT();
  TOSH_MAKE_FLASH_HOLD_OUTPUT();
  TOSH_MAKE_FLASH_CS_OUTPUT();
  TOSH_SET_FLASH_HOLD_PIN();
  TOSH_SET_FLASH_CS_PIN();

  TOSH_wait();


  TOSH_CLR_FLASH_CS_PIN();
  TOSH_CLR_UCLK0_PIN();

  TOSH_FLASH_M25P_DP_bit(TRUE);
  TOSH_FLASH_M25P_DP_bit(FALSE);
  TOSH_FLASH_M25P_DP_bit(TRUE);
  TOSH_FLASH_M25P_DP_bit(TRUE);
  TOSH_FLASH_M25P_DP_bit(TRUE);
  TOSH_FLASH_M25P_DP_bit(FALSE);
  TOSH_FLASH_M25P_DP_bit(FALSE);
  TOSH_FLASH_M25P_DP_bit(TRUE);

  TOSH_SET_FLASH_CS_PIN();

  TOSH_SET_SIMO0_PIN();
  TOSH_MAKE_SIMO0_INPUT();
  TOSH_MAKE_UCLK0_INPUT();
  TOSH_CLR_FLASH_HOLD_PIN();
}

static 
# 174 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/msp430hardware.h"
__inline void TOSH_uwait(uint16_t u)
{
  uint16_t i;

#line 177
  if (u < 500) {
    for (i = 2; i < u; i++) {
         __asm volatile ("nop\n\t" "nop\n\t" "nop\n\t" "nop\n\t");
		}
  }
  else {

    for (i = 0; i < u; i++) {
         __asm volatile ("nop\n\t" "nop\n\t" "nop\n\t"  "nop\n\t");
		}
    }
}

static inline 
# 129 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/telosb/hardware.h"
void TOSH_SET_PIN_DIRECTIONS(void )
{

  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {
      P1SEL = 0;
      P2SEL = 0;
      P3SEL = 0;
      P4SEL = 0;
      P5SEL = 0;
      P6SEL = 0;

      P1DIR = 0xe0;
      P1OUT = 0x00;

      P2DIR = 0x7b;
      P2OUT = 0x10;

      P3DIR = 0xf1;
      P3OUT = 0x00;

      P4DIR = 0xfd;
      P4OUT = 0xdd;

      P5DIR = 0xff;
      P5OUT = 0xff;

      P6DIR = 0xff;
      P6OUT = 0x00;

      P1IE = 0;
      P2IE = 0;






      TOSH_uwait(1024 * 10);

      TOSH_FLASH_M25P_DP();
    }
#line 170
    __nesc_atomic_end(__nesc_atomic); }
}

static inline  
# 35 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/HPLInitM.nc"
result_t HPLInitM$init(void)
{
  TOSH_SET_PIN_DIRECTIONS();
  HPLInitM$MSP430ClockControl$init();
  HPLInitM$MSP430ClockControl$start();
  return SUCCESS;
}

# 47 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MainM.nc"
inline static  result_t MainM$hardwareInit(void){
#line 47
  unsigned char result;
#line 47

#line 47
  result = HPLInitM$init();
#line 47

#line 47
  return result;
#line 47
}
#line 47
static inline 
# 79 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/sched.c"
void TOSH_sched_init(void )
{
  int i;

#line 82
  TOSH_sched_free = 0;
  TOSH_sched_full = 0;
  for (i = 0; i < TOSH_MAX_TASKS; i++) 
    TOSH_queue[i].tp = NULL;
}

static inline 
# 120 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/tos.h"
result_t rcombine(result_t r1, result_t r2)



{
  return r1 == FAIL ? FAIL : r2;
}

static inline  
# 49 "BlinkM.nc"
result_t BlinkM$StdControl$init(void)
#line 49
{

  return SUCCESS;
}

static inline   
# 422 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$ControlB3$disableEvents(void)
#line 422
{
#line 422
  MSP430TimerM$TBCCTL3 &= ~0x0010;
}

# 39 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerControl.nc"
inline static   void TimerM$AlarmControl$disableEvents(void){
#line 39
  MSP430TimerM$ControlB3$disableEvents();
#line 39
}
#line 39
static inline 
# 95 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CC2int(MSP430TimerM$CC_t x)
#line 95
{
#line 95
  union __nesc_unnamed4283 {
#line 95
    MSP430TimerM$CC_t f;
#line 95
    uint16_t t;
  } 
#line 95
  c = { .f = x };

#line 95
  return c.t;
}

static inline uint16_t MSP430TimerM$compareControl(void)
{
  MSP430TimerM$CC_t x = { 
  .cm = 1, 
  .ccis = 0, 
  .clld = 0, 
  .cap = 0, 
  .ccie = 0 };

  return MSP430TimerM$CC2int(x);
}

static inline   
#line 382
void MSP430TimerM$ControlB3$setControlAsCompare(void)
#line 382
{
#line 382
  MSP430TimerM$TBCCTL3 = MSP430TimerM$compareControl();
}

# 35 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerControl.nc"
inline static   void TimerM$AlarmControl$setControlAsCompare(void){
#line 35
  MSP430TimerM$ControlB3$setControlAsCompare();
#line 35
}
#line 35
static inline  
# 72 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$StdControl$init(void)
{
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
#line 74
    TimerM$m_hinow = 0;
#line 74
    __nesc_atomic_end(__nesc_atomic); }
  TimerM$m_head_short = TimerM$EMPTY_LIST;
  TimerM$m_head_long = TimerM$EMPTY_LIST;
  bzero(TimerM$m_timers, sizeof TimerM$m_timers);
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
#line 78
    TimerM$m_posted_checkShortTimers = FALSE;
#line 78
    __nesc_atomic_end(__nesc_atomic); }
  TimerM$AlarmControl$setControlAsCompare();
  TimerM$AlarmControl$disableEvents();
  return SUCCESS;
}

# 63 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
inline static  result_t MainM$StdControl$init(void){
#line 63
  unsigned char result;
#line 63

#line 63
  result = TimerM$StdControl$init();
#line 63
  result = rcombine(result, BlinkM$StdControl$init());
#line 63

#line 63
  return result;
#line 63
}
#line 63
static inline  
# 443 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$Timer$start(uint8_t num, char type, uint32_t milli)
{
  switch (type) 
    {
      case TIMER_REPEAT: 
        return TimerM$setTimer(num, milli * 32, TRUE);

      case TIMER_ONE_SHOT: 
        return TimerM$setTimer(num, milli * 32, FALSE);
    }

  return FAIL;
}

# 59 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/Timer.nc"
inline static  result_t BlinkM$Timer$start(char arg_0x8a66558, uint32_t arg_0x8a666b0){
#line 59
  unsigned char result;
#line 59

#line 59
  result = TimerM$Timer$start(0, arg_0x8a66558, arg_0x8a666b0);
#line 59

#line 59
  return result;
#line 59
}
#line 59
static inline  
# 60 "BlinkM.nc"
result_t BlinkM$StdControl$start(void)
#line 60
{

  return BlinkM$Timer$start(TIMER_REPEAT, 2500);
}

static inline  
# 84 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$StdControl$start(void)
{
  return SUCCESS;
}

# 70 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/StdControl.nc"
inline static  result_t MainM$StdControl$start(void){
#line 70
  unsigned char result;
#line 70

#line 70
  result = TimerM$StdControl$start();
#line 70
  result = rcombine(result, BlinkM$StdControl$start());
#line 70

#line 70
  return result;
#line 70
}
#line 70
static inline 
# 113 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
void TimerM$removeTimer(uint8_t num)
{
  TimerM$m_timers[num].isset = FALSE;
}

static inline   
# 166 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$TimerB$read(void)
#line 166
{
#line 166
  return TBR;
}

# 30 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
inline static   uint16_t TimerM$AlarmTimer$read(void){
#line 30
  unsigned int result;
#line 30

#line 30
  result = MSP430TimerM$TimerB$read();
#line 30

#line 30
  return result;
#line 30
}
#line 30
static inline   
# 169 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
bool MSP430TimerM$TimerB$isOverflowPending(void)
#line 169
{
#line 169
  return TBCTL & 0x0001;
}

# 31 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
inline static   bool TimerM$AlarmTimer$isOverflowPending(void){
#line 31
  unsigned char result;
#line 31

#line 31
  result = MSP430TimerM$TimerB$isOverflowPending();
#line 31

#line 31
  return result;
#line 31
}
#line 31
static inline  
# 81 "BlinkM.nc"
result_t BlinkM$Timer$fired(void)
{
  if (BlinkM$count <= 6) {

      BlinkM$count++;
    }
  else 
#line 86
    {
    }

  return SUCCESS;
}

static inline   
# 463 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$Timer$default$fired(uint8_t num)
{
  return SUCCESS;
}

# 73 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/interfaces/Timer.nc"
inline static  result_t TimerM$Timer$fired(uint8_t arg_0x8a8ef80){
#line 73
  unsigned char result;
#line 73

#line 73
  switch (arg_0x8a8ef80) {
#line 73
    case 0:
#line 73
      result = BlinkM$Timer$fired();
#line 73
      break;
#line 73
    default:
#line 73
      result = TimerM$Timer$default$fired(arg_0x8a8ef80);
#line 73
    }
#line 73

#line 73
  return result;
#line 73
}
#line 73
static inline   
# 435 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$TimerMilli$default$fired(uint8_t num)
{
  return SUCCESS;
}

# 37 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerMilli.nc"
inline static  result_t TimerM$TimerMilli$fired(uint8_t arg_0x8a8f608){
#line 37
  unsigned char result;
#line 37

#line 37
    result = TimerM$TimerMilli$default$fired(arg_0x8a8f608);
#line 37

#line 37
  return result;
#line 37
}
#line 37
static inline   
#line 386
result_t TimerM$TimerJiffy$default$fired(uint8_t num)
{
  return SUCCESS;
}

# 37 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerJiffy.nc"
inline static  result_t TimerM$TimerJiffy$fired(uint8_t arg_0x8a60010){
#line 37
  unsigned char result;
#line 37

#line 37
    result = TimerM$TimerJiffy$default$fired(arg_0x8a60010);
#line 37

#line 37
  return result;
#line 37
}
#line 37
static inline 
#line 118
void TimerM$signal_timer_fired(uint8_t num)
{



  const int16_t num16 = num;

  if (TimerM$COUNT_TIMER_JIFFY > 0 && num16 >= TimerM$OFFSET_TIMER_JIFFY) 
    {
      TimerM$TimerJiffy$fired(num - TimerM$OFFSET_TIMER_JIFFY);
    }
  else {
#line 129
    if (TimerM$COUNT_TIMER_MILLI > 0 && num16 >= TimerM$OFFSET_TIMER_MILLI) 
      {
        TimerM$TimerMilli$fired(num - TimerM$OFFSET_TIMER_MILLI);
      }
    else 
      {
        TimerM$Timer$fired(num);
      }
    }
}

static inline   
# 470 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$CompareB3$setEventFromNow(uint16_t x)
#line 470
{
#line 470
  MSP430TimerM$TBCCR3 = TBR + x;
}

# 32 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void TimerM$AlarmCompare$setEventFromNow(uint16_t arg_0x8959668){
#line 32
  MSP430TimerM$CompareB3$setEventFromNow(arg_0x8959668);
#line 32
}
#line 32
static inline   
# 366 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$ControlB3$clearPendingInterrupt(void)
#line 366
{
#line 366
  MSP430TimerM$TBCCTL3 &= ~0x0001;
}

# 32 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerControl.nc"
inline static   void TimerM$AlarmControl$clearPendingInterrupt(void){
#line 32
  MSP430TimerM$ControlB3$clearPendingInterrupt();
#line 32
}
#line 32
static inline   
# 414 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$ControlB3$enableEvents(void)
#line 414
{
#line 414
  MSP430TimerM$TBCCTL3 |= 0x0010;
}

# 38 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerControl.nc"
inline static   void TimerM$AlarmControl$enableEvents(void){
#line 38
  MSP430TimerM$ControlB3$enableEvents();
#line 38
}
#line 38
static inline 
# 202 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/msp430hardware.h"
void __nesc_enable_interrupt(void)
{
   __asm volatile ("eint");
}

static inline 
#line 226
void __nesc_atomic_end(__nesc_atomic_t reenable_interrupts)
{
  if (reenable_interrupts) {
    __nesc_enable_interrupt();
    }
}

static 
#line 245
__inline void __nesc_atomic_sleep(void)
#line 245
{








  uint16_t LPMode_bits = 0;

  if (LPMode_disabled) {
      __nesc_enable_interrupt();
      return;
    }
  else 
#line 259
    {
      LPMode_bits = 0x0080 + 0x0040 + 0x0010;






      if (((((
#line 262
      TA0CTL & (3 << 4)) != 0 << 4 && (TA0CTL & (3 << 8)) == 2 << 8)
       || (ME1 & ((1 << 7) | (1 << 6)) && U0TCTL & 0x20))
       || (ME2 & ((1 << 5) | (1 << 4)) && U1TCTL & 0x20))


       || (U0CTLnr & 0x01 && I2CTCTLnr & 0x20 && 
      I2CDCTLnr & 0x20 && U0CTLnr & 0x04 && U0CTLnr & 0x20)) {


        LPMode_bits = 0x0040 + 0x0010;
        }

      if (ADC12CTL1 & 0x0001) {
          if (!(ADC12CTL0 & 0x0080) && (TA0CTL & (3 << 8)) == 2 << 8) {
            LPMode_bits = 0x0040 + 0x0010;
            }
          else {
#line 278
            switch (ADC12CTL1 & (3 << 3)) {
                case 2 << 3: LPMode_bits = 0;
#line 279
                break;
                case 3 << 3: LPMode_bits = 0x0040 + 0x0010;
#line 280
                break;
              }
            }
        }
      LPMode_bits |= 0x0008;
       __asm volatile ("bis  %0, r2" :  : "m"((uint16_t )LPMode_bits));}
}

static inline 
#line 196
void __nesc_disable_interrupt(void)
{
   __asm volatile ("dint");
   __asm volatile ("nop");}

static inline 





bool are_interrupts_enabled(void)
{
  return (({
#line 209
    uint16_t __x;

#line 209
     __asm volatile ("mov	r2, %0" : "=r"((uint16_t )__x));__x;
  }
  )
#line 209
   & 0x0008) != 0;
}

static inline 






__nesc_atomic_t __nesc_atomic_start(void )
{
  __nesc_atomic_t result = are_interrupts_enabled();

#line 222
  __nesc_disable_interrupt();
  return result;
}

static inline 
# 136 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/sched.c"
bool TOSH_run_next_task(void)
{
  __nesc_atomic_t fInterruptFlags;
  uint8_t old_full;
  void (*func)(void );

  fInterruptFlags = __nesc_atomic_start();
  old_full = TOSH_sched_full;
  func = TOSH_queue[old_full].tp;
  if (func == NULL) 
    {
      __nesc_atomic_sleep();
      return 0;
    }

  TOSH_queue[old_full].tp = NULL;
  TOSH_sched_full = (old_full + 1) & TOSH_TASK_BITMASK;
  __nesc_atomic_end(fInterruptFlags);
  func();

  return 1;
}

static inline void TOSH_run_task(void)
#line 159
{
  for (; ; ) 
    TOSH_run_next_task();
}

static inline    
# 157 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$CompareA0$default$fired(void)
#line 157
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareA0$fired(void){
#line 34
  MSP430TimerM$CompareA0$default$fired();
#line 34
}
#line 34
static inline   
# 253 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureA0$getEvent(void)
#line 253
{
#line 253
  return MSP430TimerM$TA0CCR0;
}

static inline    
#line 160
void MSP430TimerM$CaptureA0$default$captured(uint16_t time)
#line 160
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureA0$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureA0$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline 
# 96 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$int2CC(uint16_t x)
#line 96
{
#line 96
  union __nesc_unnamed4284 {
#line 96
    uint16_t f;
#line 96
    MSP430TimerM$CC_t t;
  } 
#line 96
  c = { .f = x };

#line 96
  return c.t;
}

static inline   
#line 205
MSP430TimerM$CC_t MSP430TimerM$ControlA0$getControl(void)
#line 205
{
#line 205
  return MSP430TimerM$int2CC(MSP430TimerM$TA0CCTL0);
}

#line 123
void __attribute((interrupt(12))) __attribute((wakeup))  sig_TIMERA0_VECTOR(void)
{
  if (MSP430TimerM$ControlA0$getControl().cap) {
    MSP430TimerM$CaptureA0$captured(MSP430TimerM$CaptureA0$getEvent());
    }
  else {
#line 128
    MSP430TimerM$CompareA0$fired();
    }
}

static inline   
#line 206
MSP430TimerM$CC_t MSP430TimerM$ControlA1$getControl(void)
#line 206
{
#line 206
  return MSP430TimerM$int2CC(MSP430TimerM$TA0CCTL1);
}

static inline    
#line 161
void MSP430TimerM$CaptureA1$default$captured(uint16_t time)
#line 161
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureA1$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureA1$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 254 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureA1$getEvent(void)
#line 254
{
#line 254
  return MSP430TimerM$TA0CCR1;
}

static inline    
#line 158
void MSP430TimerM$CompareA1$default$fired(void)
#line 158
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareA1$fired(void){
#line 34
  MSP430TimerM$CompareA1$default$fired();
#line 34
}
#line 34
static inline   
# 207 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlA2$getControl(void)
#line 207
{
#line 207
  return MSP430TimerM$int2CC(MSP430TimerM$TA0CCTL2);
}

static inline    
#line 162
void MSP430TimerM$CaptureA2$default$captured(uint16_t time)
#line 162
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureA2$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureA2$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 255 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureA2$getEvent(void)
#line 255
{
#line 255
  return MSP430TimerM$TA0CCR2;
}

static inline    
#line 159
void MSP430TimerM$CompareA2$default$fired(void)
#line 159
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareA2$fired(void){
#line 34
  MSP430TimerM$CompareA2$default$fired();
#line 34
}
#line 34
# 30 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
inline static   uint16_t MSP430DCOCalibM$Timer32khz$read(void){
#line 30
  unsigned int result;
#line 30

#line 30
  result = MSP430TimerM$TimerB$read();
#line 30

#line 30
  return result;
#line 30
}
#line 30
static inline   
# 41 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430DCOCalibM.nc"
void MSP430DCOCalibM$TimerMicro$overflow(void)
{
  uint16_t now = MSP430DCOCalibM$Timer32khz$read();
  uint16_t delta = now - MSP430DCOCalibM$m_prev;

#line 45
  MSP430DCOCalibM$m_prev = now;

  if (delta > MSP430DCOCalibM$TARGET_DELTA + MSP430DCOCalibM$MAX_DEVIATION) 
    {

      if (DCOCTL < 0xe0) 
        {
          DCOCTL++;
        }
      else {
#line 54
        if ((BCSCTL1 & 7) < 7) 
          {
            BCSCTL1++;
            DCOCTL = 96;
          }
        }
    }
  else {
#line 60
    if (delta < MSP430DCOCalibM$TARGET_DELTA - MSP430DCOCalibM$MAX_DEVIATION) 
      {

        if (DCOCTL > 0) 
          {
            DCOCTL--;
          }
        else {
#line 67
          if ((BCSCTL1 & 7) > 0) 
            {
              BCSCTL1--;
              DCOCTL = 128;
            }
          }
      }
    }
}

# 33 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
inline static   void MSP430TimerM$TimerA$overflow(void){
#line 33
  MSP430DCOCalibM$TimerMicro$overflow();
#line 33
}
#line 33
static inline    
# 331 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void MSP430TimerM$CompareB0$default$fired(void)
#line 331
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB0$fired(void){
#line 34
  MSP430TimerM$CompareB0$default$fired();
#line 34
}
#line 34
static inline   
# 443 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB0$getEvent(void)
#line 443
{
#line 443
  return MSP430TimerM$TBCCR0;
}

static inline    
#line 338
void MSP430TimerM$CaptureB0$default$captured(uint16_t time)
#line 338
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB0$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB0$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 347 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB0$getControl(void)
#line 347
{
#line 347
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL0);
}

#line 277
void __attribute((interrupt(26))) __attribute((wakeup))  sig_TIMERB0_VECTOR(void)
{
  if (MSP430TimerM$ControlB0$getControl().cap) {
    MSP430TimerM$CaptureB0$captured(MSP430TimerM$CaptureB0$getEvent());
    }
  else {
#line 282
    MSP430TimerM$CompareB0$fired();
    }
}

static inline   
#line 348
MSP430TimerM$CC_t MSP430TimerM$ControlB1$getControl(void)
#line 348
{
#line 348
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL1);
}

static inline    
#line 339
void MSP430TimerM$CaptureB1$default$captured(uint16_t time)
#line 339
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB1$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB1$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 444 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB1$getEvent(void)
#line 444
{
#line 444
  return MSP430TimerM$TBCCR1;
}

static inline    
#line 332
void MSP430TimerM$CompareB1$default$fired(void)
#line 332
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB1$fired(void){
#line 34
  MSP430TimerM$CompareB1$default$fired();
#line 34
}
#line 34
static inline   
# 349 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB2$getControl(void)
#line 349
{
#line 349
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL2);
}

static inline    
#line 340
void MSP430TimerM$CaptureB2$default$captured(uint16_t time)
#line 340
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB2$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB2$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 445 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB2$getEvent(void)
#line 445
{
#line 445
  return MSP430TimerM$TBCCR2;
}

static inline    
#line 333
void MSP430TimerM$CompareB2$default$fired(void)
#line 333
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB2$fired(void){
#line 34
  MSP430TimerM$CompareB2$default$fired();
#line 34
}
#line 34
static inline   
# 350 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB3$getControl(void)
#line 350
{
#line 350
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL3);
}

static inline    
#line 341
void MSP430TimerM$CaptureB3$default$captured(uint16_t time)
#line 341
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB3$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB3$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 446 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB3$getEvent(void)
#line 446
{
#line 446
  return MSP430TimerM$TBCCR3;
}

static inline  
# 257 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
void TimerM$checkShortTimers(void)
{
  uint8_t head = TimerM$m_head_short;

#line 260
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
#line 260
    TimerM$m_posted_checkShortTimers = FALSE;
#line 260
    __nesc_atomic_end(__nesc_atomic); }
  TimerM$m_head_short = TimerM$EMPTY_LIST;
  TimerM$executeTimers(head);
  TimerM$setNextShortEvent();
}

static inline 
#line 186
void TimerM$post_checkShortTimers(void)
{
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {
      if (!TimerM$m_posted_checkShortTimers) 
        {
          if (TOS_post(TimerM$checkShortTimers)) {
            TimerM$m_posted_checkShortTimers = TRUE;
            }
        }
    }
#line 196
    __nesc_atomic_end(__nesc_atomic); }
}

static inline   
#line 308
void TimerM$AlarmCompare$fired(void)
{
  TimerM$post_checkShortTimers();
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB3$fired(void){
#line 34
  TimerM$AlarmCompare$fired();
#line 34
}
#line 34
static inline   
# 351 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB4$getControl(void)
#line 351
{
#line 351
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL4);
}

static inline    
#line 342
void MSP430TimerM$CaptureB4$default$captured(uint16_t time)
#line 342
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB4$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB4$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 447 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB4$getEvent(void)
#line 447
{
#line 447
  return MSP430TimerM$TBCCR4;
}

static inline    
#line 335
void MSP430TimerM$CompareB4$default$fired(void)
#line 335
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB4$fired(void){
#line 34
  MSP430TimerM$CompareB4$default$fired();
#line 34
}
#line 34
static inline   
# 352 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB5$getControl(void)
#line 352
{
#line 352
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL5);
}

static inline    
#line 343
void MSP430TimerM$CaptureB5$default$captured(uint16_t time)
#line 343
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB5$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB5$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 448 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB5$getEvent(void)
#line 448
{
#line 448
  return MSP430TimerM$TBCCR5;
}

static inline    
#line 336
void MSP430TimerM$CompareB5$default$fired(void)
#line 336
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB5$fired(void){
#line 34
  MSP430TimerM$CompareB5$default$fired();
#line 34
}
#line 34
static inline   
# 353 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
MSP430TimerM$CC_t MSP430TimerM$ControlB6$getControl(void)
#line 353
{
#line 353
  return MSP430TimerM$int2CC(MSP430TimerM$TBCCTL6);
}

static inline    
#line 344
void MSP430TimerM$CaptureB6$default$captured(uint16_t time)
#line 344
{
}

# 74 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Capture.nc"
inline static   void MSP430TimerM$CaptureB6$captured(uint16_t arg_0x8995108){
#line 74
  MSP430TimerM$CaptureB6$default$captured(arg_0x8995108);
#line 74
}
#line 74
static inline   
# 449 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
uint16_t MSP430TimerM$CaptureB6$getEvent(void)
#line 449
{
#line 449
  return MSP430TimerM$TBCCR6;
}

static inline    
#line 337
void MSP430TimerM$CompareB6$default$fired(void)
#line 337
{
}

# 34 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Compare.nc"
inline static   void MSP430TimerM$CompareB6$fired(void){
#line 34
  MSP430TimerM$CompareB6$default$fired();
#line 34
}
#line 34
static inline   
# 75 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430DCOCalibM.nc"
void MSP430DCOCalibM$Timer32khz$overflow(void)
{
}

static inline  
# 266 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
void TimerM$checkLongTimers(void)
{
  uint8_t head = TimerM$m_head_long;

#line 269
  TimerM$m_head_long = TimerM$EMPTY_LIST;
  TimerM$executeTimers(head);
  TimerM$setNextShortEvent();
}

static inline   
#line 313
void TimerM$AlarmTimer$overflow(void)
{
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
#line 315
    TimerM$m_hinow++;
#line 315
    __nesc_atomic_end(__nesc_atomic); }
  TOS_post(TimerM$checkLongTimers);
}

# 33 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430Timer.nc"
inline static   void MSP430TimerM$TimerB$overflow(void){
#line 33
  TimerM$AlarmTimer$overflow();
#line 33
  MSP430DCOCalibM$Timer32khz$overflow();
#line 33
}
#line 33
# 102 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/system/sched.c"
bool  TOS_post(void (*tp)(void))
#line 102
{
  __nesc_atomic_t fInterruptFlags;
  uint8_t tmp;



  fInterruptFlags = __nesc_atomic_start();

  tmp = TOSH_sched_free;

  if (TOSH_queue[tmp].tp == NULL) {
      TOSH_sched_free = (tmp + 1) & TOSH_TASK_BITMASK;
      TOSH_queue[tmp].tp = tp;
      __nesc_atomic_end(fInterruptFlags);

      return TRUE;
    }
  else {
      __nesc_atomic_end(fInterruptFlags);

      return FALSE;
    }
}

# 52 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MainM.nc"
int   main(void)
{
  MainM$hardwareInit();
  TOSH_sched_init();

  MainM$StdControl$init();
  MainM$StdControl$start();
  __nesc_enable_interrupt();

  for (; ; ) {
#line 61
      TOSH_run_task();
    }
}

static 
# 139 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430ClockM.nc"
void MSP430ClockM$set_dco_calib(int calib)
{
  BCSCTL1 = (BCSCTL1 & ~0x07) | ((calib >> 8) & 0x07);
  DCOCTL = calib & 0xff;
}

static 
# 319 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/TimerM.nc"
result_t TimerM$setTimer(uint8_t num, int32_t jiffy, bool isperiodic)
{
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {
      TimerM$Timer_t *timer = &TimerM$m_timers[num];
      int32_t now;

#line 325
      if (timer->isset) {
        TimerM$removeTimer(num);
        }
#line 327
      TimerM$m_period[num] = jiffy;
      timer->isperiodic = isperiodic;
      now = TimerM$LocalTime$read();
      timer->alarm = now + jiffy;
      TimerM$insertTimer(num, jiffy <= 0xffffL);
      TimerM$setNextShortEvent();
    }
#line 333
    __nesc_atomic_end(__nesc_atomic); }
  return SUCCESS;
}

static   
#line 288
uint32_t TimerM$LocalTime$read(void)
{
  uint32_t now;

#line 291
  { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
    {



      uint16_t hinow = TimerM$m_hinow;
      uint16_t lonow = TimerM$readTime();

#line 298
      if (TimerM$AlarmTimer$isOverflowPending()) 
        {
          hinow++;
          lonow = TimerM$readTime();
        }
      now = ((uint32_t )hinow << 16) | lonow;
    }
#line 304
    __nesc_atomic_end(__nesc_atomic); }
  return now;
}

static 
#line 275
uint16_t TimerM$readTime(void)
{





  uint16_t t0;
  uint16_t t1 = TimerM$AlarmTimer$read();

#line 284
  do {
#line 284
      t0 = t1;
#line 284
      t1 = TimerM$AlarmTimer$read();
    }
  while (
#line 284
  t0 != t1);
  return t1;
}

static 
#line 94
void TimerM$insertTimer(uint8_t num, bool isshort)
{
  if (TimerM$m_timers[num].isqueued == FALSE) 
    {
      if (isshort) 
        {
          TimerM$m_timers[num].next = TimerM$m_head_short;
          TimerM$m_head_short = num;
        }
      else 
        {
          TimerM$m_timers[num].next = TimerM$m_head_long;
          TimerM$m_head_long = num;
        }
      TimerM$m_timers[num].isqueued = TRUE;
    }
  TimerM$m_timers[num].isset = TRUE;
}

static 
#line 198
void TimerM$setNextShortEvent(void)
{
  uint32_t now = TimerM$LocalTime$read();

#line 201
  if (TimerM$m_head_short != TimerM$EMPTY_LIST) 
    {
      uint8_t head = TimerM$m_head_short;
      uint8_t soon = head;
      int32_t remaining = TimerM$m_timers[head].alarm - now;

#line 206
      head = TimerM$m_timers[head].next;
      while (head != TimerM$EMPTY_LIST) 
        {
          int32_t dt = TimerM$m_timers[head].alarm - now;

#line 210
          if (dt < remaining) 
            {
              remaining = dt;
              soon = head;
            }
          head = TimerM$m_timers[head].next;
        }

      now = TimerM$LocalTime$read();
      remaining = TimerM$m_timers[soon].alarm - now;

      if (remaining <= 0) 
        {

          TimerM$AlarmControl$disableEvents();
          TimerM$post_checkShortTimers();
        }
      else 
        {


          { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
            {




              if (remaining > 2) {
                TimerM$AlarmCompare$setEventFromNow(remaining);
                }
              else {
#line 240
                TimerM$AlarmCompare$setEventFromNow(2);
                }
#line 241
              TimerM$AlarmControl$clearPendingInterrupt();
              TimerM$AlarmControl$enableEvents();
            }
#line 243
            __nesc_atomic_end(__nesc_atomic); }
        }
    }
  else 
    {

      TimerM$AlarmControl$disableEvents();
    }
}

static 
#line 141
void TimerM$executeTimers(uint8_t head)
{
  uint32_t now = TimerM$LocalTime$read();

#line 144
  while (head != TimerM$EMPTY_LIST) 
    {
      uint8_t num = head;
      bool signal_timer = FALSE;

      { __nesc_atomic_t __nesc_atomic = __nesc_atomic_start();
        {
          TimerM$Timer_t *timer = &TimerM$m_timers[num];

#line 152
          head = timer->next;

          timer->isqueued = FALSE;

          if (timer->isset) 
            {
              int32_t remaining = timer->alarm - now;

#line 159
              timer->isset = FALSE;
              if (remaining <= 0) 
                {


                  if (timer->isperiodic) 
                    {
                      timer->alarm += TimerM$m_period[num];
                      TimerM$insertTimer(num, (int32_t )(timer->alarm - now) <= 0xffffL);
                    }
                  signal_timer = TRUE;
                }
              else 
                {

                  TimerM$insertTimer(num, remaining <= 0xffffL);
                }
            }
        }
#line 177
        __nesc_atomic_end(__nesc_atomic); }

      if (signal_timer) {
        TimerM$signal_timer_fired(num);
        }
    }
}

# 131 "/usr/local/unison/packages/tinyos/tinyos-1.x/tos/platform/msp430/MSP430TimerM.nc"
void __attribute((interrupt(10))) __attribute((wakeup))  sig_TIMERA1_VECTOR(void)
{
  int n = TA0IV;

#line 134
  switch (n) 
    {
      case 0: break;
      case 2: 
        if (MSP430TimerM$ControlA1$getControl().cap) {
          MSP430TimerM$CaptureA1$captured(MSP430TimerM$CaptureA1$getEvent());
          }
        else {
#line 141
          MSP430TimerM$CompareA1$fired();
          }
#line 142
      break;
      case 4: 
        if (MSP430TimerM$ControlA2$getControl().cap) {
          MSP430TimerM$CaptureA2$captured(MSP430TimerM$CaptureA2$getEvent());
          }
        else {
#line 147
          MSP430TimerM$CompareA2$fired();
          }
#line 148
      break;
      case 6: break;
      case 8: break;
      case 10: MSP430TimerM$TimerA$overflow();
#line 151
      break;
      case 12: break;
      case 14: break;
    }
}

#line 285
void __attribute((interrupt(24))) __attribute((wakeup))  sig_TIMERB1_VECTOR(void)
{
  int n = TBIV;

#line 288
  switch (n) 
    {
      case 0: break;
      case 2: 
        if (MSP430TimerM$ControlB1$getControl().cap) {
          MSP430TimerM$CaptureB1$captured(MSP430TimerM$CaptureB1$getEvent());
          }
        else {
#line 295
          MSP430TimerM$CompareB1$fired();
          }
#line 296
      break;
      case 4: 
        if (MSP430TimerM$ControlB2$getControl().cap) {
          MSP430TimerM$CaptureB2$captured(MSP430TimerM$CaptureB2$getEvent());
          }
        else {
#line 301
          MSP430TimerM$CompareB2$fired();
          }
#line 302
      break;
      case 6: 
        if (MSP430TimerM$ControlB3$getControl().cap) {
          MSP430TimerM$CaptureB3$captured(MSP430TimerM$CaptureB3$getEvent());
          }
        else {
#line 307
          MSP430TimerM$CompareB3$fired();
          }
#line 308
      break;
      case 8: 
        if (MSP430TimerM$ControlB4$getControl().cap) {
          MSP430TimerM$CaptureB4$captured(MSP430TimerM$CaptureB4$getEvent());
          }
        else {
#line 313
          MSP430TimerM$CompareB4$fired();
          }
#line 314
      break;
      case 10: 
        if (MSP430TimerM$ControlB5$getControl().cap) {
          MSP430TimerM$CaptureB5$captured(MSP430TimerM$CaptureB5$getEvent());
          }
        else {
#line 319
          MSP430TimerM$CompareB5$fired();
          }
#line 320
      break;
      case 12: 
        if (MSP430TimerM$ControlB6$getControl().cap) {
          MSP430TimerM$CaptureB6$captured(MSP430TimerM$CaptureB6$getEvent());
          }
        else {
#line 325
          MSP430TimerM$CompareB6$fired();
          }
#line 326
      break;
      case 14: MSP430TimerM$TimerB$overflow();
#line 327
      break;
    }
}

